diff --git a/gdb/testsuite/gdb.ada/assign_arr.exp b/gdb/testsuite/gdb.ada/assign_arr.exp
index 26e2dcda8e..3da07ba99c 100644
--- a/gdb/testsuite/gdb.ada/assign_arr.exp
+++ b/gdb/testsuite/gdb.ada/assign_arr.exp
@@ -26,5 +26,5 @@ clean_restart ${testfile}
 set bp_location [gdb_get_line_number "STOP" ${testdir}/main_p324_051.adb]
 runto "main_p324_051.adb:$bp_location"
 
-gdb_test "print input.u2 := (0.25,0.5,0.75)" \
+gdb_test "print assign_arr_input.u2 := (0.25,0.5,0.75)" \
          " = \\(0\\.25, 0\\.5, 0\\.75\\)"
diff --git a/gdb/testsuite/gdb.ada/assign_arr/main_p324_051.adb b/gdb/testsuite/gdb.ada/assign_arr/main_p324_051.adb
index d102dd3e67..60010ccc09 100644
--- a/gdb/testsuite/gdb.ada/assign_arr/main_p324_051.adb
+++ b/gdb/testsuite/gdb.ada/assign_arr/main_p324_051.adb
@@ -17,5 +17,5 @@ with target_wrapper; use target_wrapper;
 
 procedure Main_P324_051 is
 begin
-   input.u2 := (0.2,0.3,0.4);  -- STOP
+   Assign_Arr_Input.u2 := (0.2,0.3,0.4);  -- STOP
 end Main_P324_051;
diff --git a/gdb/testsuite/gdb.ada/assign_arr/target_wrapper.ads b/gdb/testsuite/gdb.ada/assign_arr/target_wrapper.ads
index a58c98790f..deb9e747b2 100644
--- a/gdb/testsuite/gdb.ada/assign_arr/target_wrapper.ads
+++ b/gdb/testsuite/gdb.ada/assign_arr/target_wrapper.ads
@@ -21,6 +21,6 @@ package target_wrapper is
       u2 : Float_Array_3;
    end record;
 
-   input : parameters;
+   Assign_Arr_Input : parameters;
 
 end target_wrapper;
diff --git a/gdb/testsuite/gdb.ada/fun_renaming.exp b/gdb/testsuite/gdb.ada/fun_renaming.exp
index 4d4116cc13..cbdd0032ea 100644
--- a/gdb/testsuite/gdb.ada/fun_renaming.exp
+++ b/gdb/testsuite/gdb.ada/fun_renaming.exp
@@ -27,18 +27,18 @@ set bp_location [gdb_get_line_number "BREAK" ${testdir}/fun_renaming.adb]
 runto "fun_renaming.adb:$bp_location"
 
 # Sanity check: make sure we can call a regular global function.
-gdb_test "print next(1)" " = 2"
+gdb_test "print fun_rename_test_next(1)" " = 2"
 
 # Starting with GCC 6, renamed subprograms are materialized in the debugging
 # information: make sure we can call the regular global function using its
 # multiple names.
 
-set test "print n(1)"
+set test "print fun_rename_test_n(1)"
 gdb_test_multiple $test $test {
     -re " = 2\..*$gdb_prompt $"  {
         pass $test
     }
-    -re "No definition of \"n\" in current context\..*$gdb_prompt $" {
+    -re "No definition of \"fun_rename_test_n\" in current context\..*$gdb_prompt $" {
         if {[test_compiler_info {gcc-6*}]} {
             fail $test
         } else {
@@ -47,12 +47,12 @@ gdb_test_multiple $test $test {
     }
 
 }
-set test "print renamed_next(1)"
+set test "print renamed_fun_rename_test_next(1)"
 gdb_test_multiple $test $test {
     -re " = 2\..*$gdb_prompt $" {
         pass $test
     }
-    -re "No definition of \"renamed_next\" in current context\..*$gdb_prompt $" {
+    -re "No definition of \"renamed_fun_rename_test_next\" in current context\..*$gdb_prompt $" {
         if {[test_compiler_info {gcc-6*}]} {
             fail $test
         } else {
@@ -61,12 +61,12 @@ gdb_test_multiple $test $test {
     }
 }
 
-set test "print pack.renamed_next(1)"
+set test "print pack.renamed_fun_rename_test_next(1)"
 gdb_test_multiple $test $test {
     -re " = 2\..*$gdb_prompt $" {
         pass $test
     }
-    -re "No definition of \"pack\.renamed_next\" in current context\..*$gdb_prompt $" {
+    -re "No definition of \"pack\.renamed_fun_rename_test_next\" in current context\..*$gdb_prompt $" {
         if {[test_compiler_info {gcc-6*}]} {
             fail $test
         } else {
diff --git a/gdb/testsuite/gdb.ada/fun_renaming/fun_renaming.adb b/gdb/testsuite/gdb.ada/fun_renaming/fun_renaming.adb
index eae6eeaf73..12cec24a56 100644
--- a/gdb/testsuite/gdb.ada/fun_renaming/fun_renaming.adb
+++ b/gdb/testsuite/gdb.ada/fun_renaming/fun_renaming.adb
@@ -16,8 +16,9 @@
 with Pack;
 
 procedure Fun_Renaming is
-   function N (I : Integer) return Integer renames Pack.Next;
+   function Fun_Rename_Test_N (I : Integer) return Integer
+     renames Pack.Fun_Rename_Test_Next;
 begin
-   Pack.Discard (N (1)); --  BREAK
-   Pack.Discard (Pack.Renamed_Next (1)); --  BREAK
+   Pack.Discard (Fun_Rename_Test_N (1)); --  BREAK
+   Pack.Discard (Pack.Renamed_Fun_Rename_Test_Next (1)); --  BREAK
 end Fun_Renaming;
diff --git a/gdb/testsuite/gdb.ada/fun_renaming/pack.adb b/gdb/testsuite/gdb.ada/fun_renaming/pack.adb
index abbec2a284..5349cdee5a 100644
--- a/gdb/testsuite/gdb.ada/fun_renaming/pack.adb
+++ b/gdb/testsuite/gdb.ada/fun_renaming/pack.adb
@@ -14,10 +14,10 @@
 --  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 package body Pack is
-   function Next (I : Integer) return Integer is
+   function Fun_Rename_Test_Next (I : Integer) return Integer is
    begin
       return I + 1;
-   end Next;
+   end Fun_Rename_Test_Next;
 
    procedure Discard (I : Integer) is
    begin
diff --git a/gdb/testsuite/gdb.ada/fun_renaming/pack.ads b/gdb/testsuite/gdb.ada/fun_renaming/pack.ads
index be46315440..ba3a999f42 100644
--- a/gdb/testsuite/gdb.ada/fun_renaming/pack.ads
+++ b/gdb/testsuite/gdb.ada/fun_renaming/pack.ads
@@ -15,8 +15,9 @@
 
 package Pack is
 
-   function Next (I : Integer) return Integer;
-   function Renamed_Next (I : Integer) return Integer renames Next;
+   function Fun_Rename_Test_Next (I : Integer) return Integer;
+   function Renamed_Fun_Rename_Test_Next (I : Integer) return Integer
+     renames Fun_Rename_Test_Next;
    procedure Discard (I : Integer);
 
 end Pack;
diff --git a/gdb/testsuite/gdb.ada/packed_array_assign.exp b/gdb/testsuite/gdb.ada/packed_array_assign.exp
index 25b20dd223..c978896c2d 100644
--- a/gdb/testsuite/gdb.ada/packed_array_assign.exp
+++ b/gdb/testsuite/gdb.ada/packed_array_assign.exp
@@ -26,5 +26,5 @@ clean_restart ${testfile}
 runto "aggregates.run_test"
 
 gdb_test \
-    "print pra := ((x => 2, y => 0, w => 17), pr, (x => 7, y => 1, w => 23))" \
-    " = \\(\\(w => 17, x => 2, y => 0\\), \\(w => 104, x => 2, y => 3\\), \\(w => 23, x => 7, y => 1\\)\\)"
+    "print pra := ((packed_array_assign_x => 2, packed_array_assign_y => 0, packed_array_assign_w => 17), pr, (packed_array_assign_x => 7, packed_array_assign_y => 1, packed_array_assign_w => 23))" \
+    " = \\(\\(packed_array_assign_x => 2, packed_array_assign_y => 0, packed_array_assign_w => 17\\), \\(packed_array_assign_x => 2, packed_array_assign_y => 3, packed_array_assign_w => 104\\), \\(packed_array_assign_x => 7, packed_array_assign_y => 1, packed_array_assign_w => 23\\)\\)"
diff --git a/gdb/testsuite/gdb.ada/packed_array_assign/aggregates.ads b/gdb/testsuite/gdb.ada/packed_array_assign/aggregates.ads
index b43f70ade7..8d58b9b44a 100644
--- a/gdb/testsuite/gdb.ada/packed_array_assign/aggregates.ads
+++ b/gdb/testsuite/gdb.ada/packed_array_assign/aggregates.ads
@@ -17,8 +17,8 @@ package Aggregates is
    subtype Int is Integer range 0 .. 7;
 
    type Packed_Rec is record
-      X, Y : Int;
-      W    : Integer;
+      Packed_Array_Assign_X, Packed_Array_Assign_Y : Int;
+      Packed_Array_Assign_W    : Integer;
    end record;
    pragma Pack (Packed_Rec);
 
@@ -28,6 +28,8 @@ package Aggregates is
    procedure Run_Test;
 
 private
-   PR : Packed_Rec := (y => 3, w => 104, x => 2);
+   PR : Packed_Rec := (Packed_Array_Assign_Y => 3,
+                       Packed_Array_Assign_W => 104,
+                       Packed_Array_Assign_X  => 2);
    PRA : Packed_RecArr (1 .. 3);
 end Aggregates;
diff --git a/gdb/testsuite/gdb.ada/rename_subscript_param.exp b/gdb/testsuite/gdb.ada/rename_subscript_param.exp
index 9188bf0fa5..79370cfca2 100644
--- a/gdb/testsuite/gdb.ada/rename_subscript_param.exp
+++ b/gdb/testsuite/gdb.ada/rename_subscript_param.exp
@@ -26,9 +26,9 @@ clean_restart ${testfile}
 set bp_location [gdb_get_line_number "BREAK" ${testdir}/pkg.adb]
 runto "pkg.adb:$bp_location"
 
-gdb_test "print b" \
+gdb_test "print rename_subscript_param_b" \
          " = false" \
-         "print b before changing its value"
+         "print rename_subscript_param_b before changing its value"
 
 set bp_location [gdb_get_line_number "Do_Nothing" ${testdir}/pkg.adb]
 gdb_test "break pkg.adb:$bp_location" \
@@ -39,6 +39,6 @@ gdb_test "cont" \
          "Breakpoint \[0-9\]+, pkg.flip \\(.*" \
          "Continuing to breakpoint on call to Do_Nothing"
 
-gdb_test "print b" \
+gdb_test "print rename_subscript_param_b" \
          " = true" \
-         "print b before changing its value"
+         "print rename_subscript_param_b after changing its value"
diff --git a/gdb/testsuite/gdb.ada/rename_subscript_param/pkg.adb b/gdb/testsuite/gdb.ada/rename_subscript_param/pkg.adb
index cdbcd36ea5..c03fe16ad8 100644
--- a/gdb/testsuite/gdb.ada/rename_subscript_param/pkg.adb
+++ b/gdb/testsuite/gdb.ada/rename_subscript_param/pkg.adb
@@ -21,9 +21,9 @@ package body Pkg is
       --  Create a new scope to check that the scope match algorithm is fine in
       --  the front-end.
       declare
-         B : Boolean renames Bits (I);
+         Rename_Subscript_Param_B : Boolean renames Bits (I);
       begin
-         B := not B; -- BREAK
+         Rename_Subscript_Param_B := not Rename_Subscript_Param_B; -- BREAK
          Do_Nothing (Bits'Address);
       end;
    end Flip;