diff --git a/gdb/python/py-arch.c b/gdb/python/py-arch.c
index cbdd881873..23cb2c5832 100644
--- a/gdb/python/py-arch.c
+++ b/gdb/python/py-arch.c
@@ -22,7 +22,6 @@
 #include "arch-utils.h"
 #include "disasm.h"
 #include "python-internal.h"
-#include "py-ref.h"
 
 typedef struct arch_object_type_object {
   PyObject_HEAD
diff --git a/gdb/python/py-bpevent.c b/gdb/python/py-bpevent.c
index 6bdbd8cb1b..64bd50e6cf 100644
--- a/gdb/python/py-bpevent.c
+++ b/gdb/python/py-bpevent.c
@@ -19,7 +19,6 @@
 
 #include "defs.h"
 #include "py-stopevent.h"
-#include "py-ref.h"
 
 /* Create and initialize a BreakpointEvent object.  This acquires new
    references to BREAKPOINT_LIST and FIRST_BP.  */
diff --git a/gdb/python/py-cmd.c b/gdb/python/py-cmd.c
index bc18cec436..1677c3dcec 100644
--- a/gdb/python/py-cmd.c
+++ b/gdb/python/py-cmd.c
@@ -27,7 +27,6 @@
 #include "cli/cli-decode.h"
 #include "completer.h"
 #include "language.h"
-#include "py-ref.h"
 
 /* Struct representing built-in completion types.  */
 struct cmdpy_completer
diff --git a/gdb/python/py-continueevent.c b/gdb/python/py-continueevent.c
index eb17766b08..b9de1971d9 100644
--- a/gdb/python/py-continueevent.c
+++ b/gdb/python/py-continueevent.c
@@ -19,7 +19,6 @@
 
 #include "defs.h"
 #include "py-event.h"
-#include "py-ref.h"
 #include "gdbthread.h"
 
 /* Create a gdb.ContinueEvent event.  gdb.ContinueEvent is-a
diff --git a/gdb/python/py-event.h b/gdb/python/py-event.h
index f4a9101794..07b99d2685 100644
--- a/gdb/python/py-event.h
+++ b/gdb/python/py-event.h
@@ -24,7 +24,6 @@
 #include "command.h"
 #include "python-internal.h"
 #include "inferior.h"
-#include "py-ref.h"
 
 /* Declare all event types.  */
 #define GDB_PY_DEFINE_EVENT_TYPE(name, py_name, doc, base) \
diff --git a/gdb/python/py-evtregistry.c b/gdb/python/py-evtregistry.c
index 941fe9df36..cf3505e654 100644
--- a/gdb/python/py-evtregistry.c
+++ b/gdb/python/py-evtregistry.c
@@ -20,7 +20,6 @@
 #include "defs.h"
 #include "command.h"
 #include "py-events.h"
-#include "py-ref.h"
 
 events_object gdb_py_events;
 
diff --git a/gdb/python/py-finishbreakpoint.c b/gdb/python/py-finishbreakpoint.c
index 6ad79cddb6..f3affbd0f4 100644
--- a/gdb/python/py-finishbreakpoint.c
+++ b/gdb/python/py-finishbreakpoint.c
@@ -30,7 +30,6 @@
 #include "inferior.h"
 #include "block.h"
 #include "location.h"
-#include "py-ref.h"
 
 /* Function that is called when a Python finish bp is found out of scope.  */
 static const char outofscope_func[] = "out_of_scope";
diff --git a/gdb/python/py-frame.c b/gdb/python/py-frame.c
index 88a50e73e2..0eef6543f8 100644
--- a/gdb/python/py-frame.c
+++ b/gdb/python/py-frame.c
@@ -28,7 +28,6 @@
 #include "symfile.h"
 #include "objfiles.h"
 #include "user-regs.h"
-#include "py-ref.h"
 
 typedef struct {
   PyObject_HEAD
diff --git a/gdb/python/py-framefilter.c b/gdb/python/py-framefilter.c
index c078e9420c..7f416cb6d3 100644
--- a/gdb/python/py-framefilter.c
+++ b/gdb/python/py-framefilter.c
@@ -30,7 +30,6 @@
 #include "demangle.h"
 #include "mi/mi-cmds.h"
 #include "python-internal.h"
-#include "py-ref.h"
 #include "common/gdb_optional.h"
 
 enum mi_print_types
diff --git a/gdb/python/py-function.c b/gdb/python/py-function.c
index dbd5649bbb..46a66cf3ec 100644
--- a/gdb/python/py-function.c
+++ b/gdb/python/py-function.c
@@ -27,7 +27,6 @@
 #include "completer.h"
 #include "expression.h"
 #include "language.h"
-#include "py-ref.h"
 
 extern PyTypeObject fnpy_object_type
     CPYCHECKER_TYPE_OBJECT_FOR_TYPEDEF ("PyObject");
diff --git a/gdb/python/py-infevents.c b/gdb/python/py-infevents.c
index dc27e0d9b5..60bafc5b41 100644
--- a/gdb/python/py-infevents.c
+++ b/gdb/python/py-infevents.c
@@ -19,7 +19,6 @@
 
 #include "defs.h"
 #include "py-event.h"
-#include "py-ref.h"
 
 /* Construct either a gdb.InferiorCallPreEvent or a
    gdb.InferiorCallPostEvent. */
diff --git a/gdb/python/py-linetable.c b/gdb/python/py-linetable.c
index a11a8d8855..b9d74b8aa3 100644
--- a/gdb/python/py-linetable.c
+++ b/gdb/python/py-linetable.c
@@ -19,7 +19,6 @@
 
 #include "defs.h"
 #include "python-internal.h"
-#include "py-ref.h"
 
 typedef struct {
   PyObject_HEAD
diff --git a/gdb/python/py-objfile.c b/gdb/python/py-objfile.c
index efad0072c2..67f63b314e 100644
--- a/gdb/python/py-objfile.c
+++ b/gdb/python/py-objfile.c
@@ -24,7 +24,6 @@
 #include "language.h"
 #include "build-id.h"
 #include "symtab.h"
-#include "py-ref.h"
 
 typedef struct
 {
diff --git a/gdb/python/py-param.c b/gdb/python/py-param.c
index 5fd4360899..3b79a5c4fd 100644
--- a/gdb/python/py-param.c
+++ b/gdb/python/py-param.c
@@ -27,7 +27,6 @@
 #include "completer.h"
 #include "language.h"
 #include "arch-utils.h"
-#include "py-ref.h"
 
 /* Parameter constants and their values.  */
 struct parm_constant
diff --git a/gdb/python/py-prettyprint.c b/gdb/python/py-prettyprint.c
index ae3001e616..8effa81d5b 100644
--- a/gdb/python/py-prettyprint.c
+++ b/gdb/python/py-prettyprint.c
@@ -25,7 +25,6 @@
 #include "extension-priv.h"
 #include "python.h"
 #include "python-internal.h"
-#include "py-ref.h"
 
 /* Return type of print_string_repr.  */
 
diff --git a/gdb/python/py-progspace.c b/gdb/python/py-progspace.c
index b80b2c260f..b82a91b44d 100644
--- a/gdb/python/py-progspace.c
+++ b/gdb/python/py-progspace.c
@@ -24,7 +24,6 @@
 #include "objfiles.h"
 #include "language.h"
 #include "arch-utils.h"
-#include "py-ref.h"
 #include "solib.h"
 #include "block.h"
 
diff --git a/gdb/python/py-symbol.c b/gdb/python/py-symbol.c
index 61667579bf..afff995068 100644
--- a/gdb/python/py-symbol.c
+++ b/gdb/python/py-symbol.c
@@ -23,7 +23,6 @@
 #include "symtab.h"
 #include "python-internal.h"
 #include "objfiles.h"
-#include "py-ref.h"
 
 typedef struct sympy_symbol_object {
   PyObject_HEAD
diff --git a/gdb/python/py-symtab.c b/gdb/python/py-symtab.c
index a5f376ae9e..0fef6e4747 100644
--- a/gdb/python/py-symtab.c
+++ b/gdb/python/py-symtab.c
@@ -24,7 +24,6 @@
 #include "python-internal.h"
 #include "objfiles.h"
 #include "block.h"
-#include "py-ref.h"
 
 typedef struct stpy_symtab_object {
   PyObject_HEAD
diff --git a/gdb/python/py-type.c b/gdb/python/py-type.c
index fff3d30220..18c1598173 100644
--- a/gdb/python/py-type.c
+++ b/gdb/python/py-type.c
@@ -28,7 +28,6 @@
 #include "language.h"
 #include "vec.h"
 #include "typeprint.h"
-#include "py-ref.h"
 
 typedef struct pyty_type_object
 {
diff --git a/gdb/python/py-unwind.c b/gdb/python/py-unwind.c
index 5fc555e1ef..f07a8d8fa2 100644
--- a/gdb/python/py-unwind.c
+++ b/gdb/python/py-unwind.c
@@ -28,7 +28,6 @@
 #include "regcache.h"
 #include "valprint.h"
 #include "user-regs.h"
-#include "py-ref.h"
 
 #define TRACE_PY_UNWIND(level, args...) if (pyuw_debug >= level)  \
   { fprintf_unfiltered (gdb_stdlog, args); }
diff --git a/gdb/python/py-utils.c b/gdb/python/py-utils.c
index 0f838c2bae..0f96aab718 100644
--- a/gdb/python/py-utils.c
+++ b/gdb/python/py-utils.c
@@ -21,7 +21,6 @@
 #include "charset.h"
 #include "value.h"
 #include "python-internal.h"
-#include "py-ref.h"
 
 /* Converts a Python 8-bit string to a unicode string object.  Assumes the
    8-bit string is in the host charset.  If an error occurs during conversion,
diff --git a/gdb/python/py-value.c b/gdb/python/py-value.c
index ebd7ef1a47..20ef5822f8 100644
--- a/gdb/python/py-value.c
+++ b/gdb/python/py-value.c
@@ -29,7 +29,6 @@
 #include "python.h"
 
 #include "python-internal.h"
-#include "py-ref.h"
 
 /* Even though Python scalar types directly map to host types, we use
    target types here to remain consistent with the values system in
diff --git a/gdb/python/py-varobj.c b/gdb/python/py-varobj.c
index 274b2dedf8..611c4ca76f 100644
--- a/gdb/python/py-varobj.c
+++ b/gdb/python/py-varobj.c
@@ -17,7 +17,6 @@
 #include "python-internal.h"
 #include "varobj.h"
 #include "varobj-iter.h"
-#include "py-ref.h"
 
 /* A dynamic varobj iterator "class" for python pretty-printed
    varobjs.  This inherits struct varobj_iter.  */
diff --git a/gdb/python/py-xmethods.c b/gdb/python/py-xmethods.c
index 2e0b2bbcc9..8606f40975 100644
--- a/gdb/python/py-xmethods.c
+++ b/gdb/python/py-xmethods.c
@@ -26,7 +26,6 @@
 
 #include "python.h"
 #include "python-internal.h"
-#include "py-ref.h"
 
 static const char enabled_field_name[] = "enabled";
 static const char match_method_name[] = "match";
diff --git a/gdb/python/python.c b/gdb/python/python.c
index d8505e968d..eafcc0414b 100644
--- a/gdb/python/python.c
+++ b/gdb/python/python.c
@@ -98,7 +98,6 @@ const struct extension_language_defn extension_language_python =
 #include "gdbthread.h"
 #include "interps.h"
 #include "event-top.h"
-#include "py-ref.h"
 #include "py-event.h"
 
 /* True if Python has been successfully initialized, false
diff --git a/gdb/varobj.c b/gdb/varobj.c
index f43910e17a..ca43a8f0c1 100644
--- a/gdb/varobj.c
+++ b/gdb/varobj.c
@@ -35,7 +35,6 @@
 #if HAVE_PYTHON
 #include "python/python.h"
 #include "python/python-internal.h"
-#include "python/py-ref.h"
 #else
 typedef int PyObject;
 #endif